#define STACK_START	0x00030000

	#include "regmap.h"

.text
	.global _start
_start:
#if 0
	mov     r0, #0x60000000
        mov     r1, #8
        str     r1, [r0, #0xc]
#endif

	mov	sp, #STACK_START 
	/*mov	sp, #0x30000*/

	mov     r0, #0
	ldr	r1, =__bss_start	/* clear bss */
1:	str	r0, [r1], #4
	cmp	r1, sp
	blo	1b

	bl	main			/* see loader.c */
2:	b	2b

	.global flush_v3
flush_v3:
	mov     r0, #0
	mcr     p15, 0, r0, c7, c7, 0	/* flush v3/v4 cache */
	mcr	p15, 0, r0, c5, c0, 0	/* flush v3 TLB */
	mov	pc, lr

	.global flush_v4
flush_v4:
	mov     r0, #0
	mcr     p15, 0, r0, c7, c7, 0	/* flush v3/v4 cache */
	mcr	p15, 0, r0, c8, c7, 0	/* flush v4 TLB */
	mov	pc, lr

	.global async_mode
async_mode:
	mrc	p15, 0, r0, c1, c0, 0
	orr	r0, r0, #0x00000000
	mcr	p15, 0, r0, c1, c0, 0
	mov	pc, lr

#if 0
	.global set_clock1
set_clock1:
	mov	r0, #0x80000000
	orr	r0, r0, #0x930000
	mov	r1, #0x02000000
	orr	r1, r1, #0xa40000
	orr	r1, r1, #0xe300
	orr	r1, r1, #0x9e
	str	r1, [r0, #0x20]
	nop
	nop
	nop
	nop
	nop
	mov	pc, lr

	.global set_clock2
set_clock2:
	mov	r0, #0x80000000
	orr	r0, r0, #0x930000
	mov	r1, #0x03000000
	orr	r1, r1, #0x0d0000
	orr	r1, r1, #0xc300
	orr	r1, r1, #0x17
	str	r1, [r0, #0x24]
	mov	pc, lr
#endif

	.global	uartbaud_115200
uartbaud_115200:
	ldr	r0, =NS_SER_CTRL_A
	ldr	r1, [r0]
	bic	r1, r1, #0x80000000
	str	r1, [r0]

	ldr	r0, =NS_SER_BITRATE
	ldr	r1, [r0]
	bic	r1, r1, #0x00007f00
	bic	r1, r1, #0x000000ff
	orr	r1, r1, #7
	str	r1, [r0]

	ldr	r0, =NS_SER_CTRL_A
	ldr	r1, [r0]
	orr	r1, r1, #0x80000000
	str	r1, [r0]
	mov	pc, lr

